<!DOCTYPE html>
<html>
<head>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css" />
  <!-- Popper Development version -->
  <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.1/dist/umd/popper.min.js"></script>
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <!-- Import DataTable Library -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <!-- Import Datatable sau jquery -->
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>
<body>
    <div class="container mt-4">
        <div class="row text-center">
            <div class="col-sm-12">
                <h2 class="font-weight-bold">Danh sách học viên</h2>
            </div>
        </div>
        <div class="row mt-4">
            <div class="col-sm-12">
                <button class="btn btn-success" id="btn-add">Thêm sinh viên</button>
            </div>
        </div>
    </div>
    <!-- Table -->
    <div class="container-fluid mt-5">
        <table class="table table-bordered table-striped table-hover" id="table">
            <thead>
                <tr>
                    <th>Id</th>
                    <th>Name</th>
                    <th>Birthday</th>
                    <th>Email</th>
                    <th>Phone</th>
                    <th>Action</th>
                </tr>
            </thead>
        </table>
    </div>
    <!-- Modal add -->
    <div class="modal fade" tabindex="-1" id="modal-add">
        <div class="modal-dialog modal-lg">
            <div class="modal-content">
                <div class="modal-header">
                    <h3>Thêm sinh viên</h3>
                    <button class="close" type="button" data-dismiss="modal">&times;</button>
                </div>
                <div class="modal-body">
                    <form>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label>Name</label>
                            </div>
                            <div class="col-sm-8">
                                <input class="form-control" id="inp-name-add" type="text">
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label>Birthday</label>
                            </div>
                            <div class="col-sm-8">
                                <input class="form-control" id="inp-birthday-add" type="date">
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label>Email</label>
                            </div>
                            <div class="col-sm-8">
                                <input class="form-control" id="inp-email-add" type="email">
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label>Phone</label>
                            </div>
                            <div class="col-sm-8">
                                <input class="form-control" id="inp-phone-add" type="text">
                            </div>
                        </div>
                    </form>
                </div>
                <div class="modal-footer">
                    <button class="btn btn-success" id="btn-add-modal">Thêm sinh viên</button>
                    <button class="btn btn-warning" data-dismiss="modal">Huỷ bỏ</button>
                </div>
            </div>
        </div>
    </div>
    <!-- Modal edit -->
    <div class="modal fade" tabindex="-1" id="modal-edit">
        <div class="modal-dialog modal-lg">
            <div class="modal-content">
                <div class="modal-header">
                    <h3>Chi tiết sinh viên</h3>
                    <button class="close" type="button" data-dismiss="modal">&times;</button>
                </div>
                <div class="modal-body">
                    <form>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label>Name</label>
                            </div>
                            <div class="col-sm-8">
                                <input class="form-control" id="inp-name-edit" type="text">
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label>Birthday</label>
                            </div>
                            <div class="col-sm-8">
                                <input class="form-control" id="inp-birthday-edit" type="text">
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label>Email</label>
                            </div>
                            <div class="col-sm-8">
                                <input class="form-control" id="inp-email-edit" type="email">
                            </div>
                        </div>
                        <div class="row form-group">
                            <div class="col-sm-4">
                                <label>Phone</label>
                            </div>
                            <div class="col-sm-8">
                                <input class="form-control" id="inp-phone-edit" type="text">
                            </div>
                        </div>
                    </form>
                </div>
                <div class="modal-footer">
                    <button class="btn btn-success" id="btn-edit-modal">Update thông tin sinh viên</button>
                    <button class="btn btn-warning" data-dismiss="modal">Huỷ bỏ</button>
                </div>
            </div>
        </div>
    </div>
    <!-- Modal delete -->
    <div class="modal fade" tabindex="-1" id="modal-delete">
        <div class="modal-dialog modal-lg">
            <div class="modal-content">
                <div class="modal-header">
                    <h3>Xác nhận xoá user</h3>
                </div>
                <div class="modal-body">
                    <p>Bạn có chắc chắn muốn xoá user này ?</p>
                </div>
                <div class="modal-footer">
                    <button class="btn btn-danger" id="btn-delete-modal">Xác nhận</button>
                    <button class="btn btn-info" data-dismiss="modal">Huỷ bỏ</button>
                </div>
            </div>
        </div>
    </div>
</body>
<script>
    "use strict"
    const gBASE_URL = "https://devcamp-student-datatables.herokuapp.com/users/";
    const gUSER_COL = ["id", "name", "birthday", "email", "phone", "action"];
    const gID = 0;
    const gNAME = 1;
    const gBIRTHDAY = 2;
    const gEMAIL = 3;
    const gPHONE = 4;
    const gACTION = 5;
    var gStt = 0;
    var gId = 0;
    var gDataTable = $("#table").DataTable({
        columns: [
            {data: gUSER_COL[gID]},
            {data: gUSER_COL[gNAME]},
            {data: gUSER_COL[gBIRTHDAY]},
            {data: gUSER_COL[gEMAIL]},
            {data: gUSER_COL[gPHONE]},
            {data: gUSER_COL[gACTION]}
        ],
        columnDefs: [
            {
                targets: gID,
                render: function() {
                    return gStt++
                }
            },
            {
                targets: gACTION,
                defaultContent: `
                    <button class="btn btn-primary" id="btn-edit">Sửa</button>
                    <button class="btn btn-danger" id="btn-delete">Xoá</button>
                    `
            }
        ]
    })
    $(document).ready(function() {
        // Load trang
        onPageLoading();
        // Khi ấn nút sửa
        $("#table").on("click", "#btn-edit", function() {
            onBtnEditClick(this);
        });
        // Khi ấn nút xoá
        $("#table").on("click", "#btn-delete", function() {
            onBtnDeleteClick(this);
        });
        // Khi ấn nút thêm sinh viên
        $("#btn-add").on("click", function() {
            onBtnAddClick();
        });
        // Khi ấn nút thêm trong modal
        $("#btn-add-modal").on("click", function() {
            onBtnAddModalClick();
        });
        // Khi ấn nút update
        $("#btn-edit-modal").on("click", function() {
            onBtnEditModalClick();
        })
        // Khi ấn nút xác nhận xoá
        $("#btn-delete-modal").on("click", function() {
            onBtnDeleteModalClick();
        });
    });
    
    // Hàm load trang
    function onPageLoading() {
        $.ajax({
            url: gBASE_URL,
            type: "GET",
            dataType: "json",
            success: function(res) {
                console.log(res);
                loadDataToTable(res);
            },
            error: function(error) {
                alert(error.responseText);
            }
        });
    }
    // Hàm load dữ liệu ra bảng
    function loadDataToTable(paramResponse) {
        gDataTable.clear();
        gDataTable.rows.add(paramResponse);
        gDataTable.draw();
    }
    // Hàm lấy dữ liệu từ bảng
    function getDataFromTable(paramButton) {
        var vRow = $(paramButton).parents("tr");
        var vDataRow = gDataTable.row(vRow).data();
        gId = vDataRow.id;
        return vDataRow;
    }
    // Khi ấn nút sửa
    function onBtnEditClick(paramButton) {
        var vData = getDataFromTable(paramButton);
        console.log(vData.id)
        $("#inp-name-edit").val(vData.name);
        $("#inp-birthday-edit").val(vData.birthday);
        $("#inp-email-edit").val(vData.email);
        $("#inp-phone-edit").val(vData.phone);
        $("#modal-edit").modal("show");
    }
    // Khi ấn nút xoá
    function onBtnDeleteClick(paramButton) {
        var vData = getDataFromTable(paramButton);
        console.log(vData.id);
        $("#modal-delete").modal("show");
    }
    // Khi ấn nút thêm
    function onBtnAddClick() {
        $("#modal-add").modal("show");
    }
    // Khi ấn nút thêm trên modal
    function onBtnAddModalClick() {
        var vUserObj = {
            name: "",
            birthday: "",
            email: "",
            phone: ""
        }
        // Thu thập dữ liệu
        getDataModalAdd(vUserObj);
        // Kiểm tra dữ liệu
        var vCheck = validateDataModal(vUserObj);
        if(vCheck) {
            // Gọi server
            postDataToServer(vUserObj);
        }
    }
    // Hàm thu thập dữ liệu
    function getDataModalAdd(paramObjData) {
        paramObjData.name = $("#inp-name-add").val();
        paramObjData.birthday = $("#inp-birthday-add").val();
        paramObjData.email = $("#inp-email-add").val();
        paramObjData.phone = $("#inp-phone-add").val();
    }
    // Hàm kiểm tra dữ liệu
    function validateDataModal(paramObjData) {
        if(paramObjData.name === "") {
            alert("Chưa điền name !");
            return false;
        }
        if(paramObjData.birthday === "") {
            alert("Chưa điền birthday !");
            return false;
        }
        if(checkEmail(paramObjData.email) === false) {
            alert("Chưa điền email, hoặc email không hợp lệ !");
            return false;
        }
        if(checkPhone(paramObjData.phone) === false) {
            alert("Chưa điền phone, hoặc phone không hợp lệ !");
            return false;
        }
        return true;
    }
    // Hàm kiểm tra email
    function checkEmail(paramEmail) {
        var vRegex = /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
        return vRegex.test(paramEmail);
    }
    // Hàm kiểm tra phone
    function checkPhone(paramPhone) {
        var vRegex = /^[\+]?[(]?[0-9]{3}[)]?[-\s\.]?[0-9]{3}[-\s\.]?[0-9]{4,6}$/im;
        return vRegex.test(paramPhone);
    }
        
    // Hàm gọi server post
    function postDataToServer(paramObjData) {
        $.ajax({
            url: gBASE_URL,
            type: "POST",
            contentType: "application/json",
            data: JSON.stringify(paramObjData),
            success: function(res) {
                console.log(res);
                alert("Thêm mới thành công !");
                window.location.href = "Task JR3.30.html";
            },
            error: function(error) {
                alert(error.responseText);
            }
        });
    }
    // Khi ấn nút update
    function onBtnEditModalClick() {
        var vUserObj = {
            name: "",
            birthday: "",
            email: "",
            phone: ""
        }
        // Thu thập dữ liệu
        getDateFromEditModal(vUserObj);
        // Kiểm tra dữ liệu
        var vCheck = validateDataModal(vUserObj);
        if(vCheck) {
            // Gọi server
            putDataToServer(vUserObj);
        }
    }
    // Hàm thu thập dữ liệu 
    function getDateFromEditModal(paramObjData) {
        paramObjData.name = $("#inp-name-edit").val();
        paramObjData.birthday = $("#inp-birthday-edit").val();
        paramObjData.email = $("#inp-email-edit").val();
        paramObjData.phone = $("#inp-phone-edit").val();
    }
    // Hàm gọi server put data
    function putDataToServer(paramObjData) {
        $.ajax({
            url: gBASE_URL + gId,
            type: "PUT",
            contentType: "application/json",
            data: JSON.stringify(paramObjData),
            success: function(res) {
                console.log(res);
                alert("Update thành công !");
                window.location.href = "Task JR3.30.html";
            },
            error: function(error) {
                alert(error.responseText);
            }
        });
    }
    // Khi ấn nút xác nhận xoá 
    function onBtnDeleteModalClick() {
        $.ajax({
            url: gBASE_URL + gId,
            type: "DELETE",
            dataType: "json",
            success: function(res) {
                console.log(res);
                alert("Xoá thành công !");
                window.location.href = "Task JR3.30.html";
            },
            error: function(error) {
                alert(error.responseText);
            }
        })
    }
</script>
</html>